//
// Created by 邹羽洋 on 2022-04-30.
//

#ifndef LINKEDLISTBASIC_LINKEDLIST2STU_H
#define LINKEDLISTBASIC_LINKEDLIST2STU_H
#pragma once
typedef struct node {
    int element;
    struct node *next;
} ListNode;

typedef struct List {
    ListNode *head;
    int elementCount;
} LinkedList;

void judge();
LinkedList *createLinkedList(void);
void addElement(int targetVal, int newNodeValue, LinkedList *obj);
void addElement2Tail(int newNodeValue, LinkedList *obj);
void addElement2Head(int newNodeValue, LinkedList *obj);
unsigned int deleteElement(int opcode, int targetVal, LinkedList *obj);
int peekElement(int index,LinkedList *obj);
int replaceElement(int index,int newNodeValue,LinkedList *obj);

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "linkedlist2stu.h"

LinkedList *StudentLinkedList;

void testLinkedList(int length, int *testdata, char *INFO);

void Test1() {
    StudentLinkedList = createLinkedList();
    if (StudentLinkedList != NULL) {
        if (StudentLinkedList->head == NULL) {
            if (StudentLinkedList->elementCount == 0) {
                printf("Lab 1. Passed\n");
            } else {
                printf("Lab 1. Failed --- elementCount = %d, expected 0\n", StudentLinkedList->elementCount);
                exit(0);
            }
        } else {
            printf("Lab 1. Failed --- **head** isn't set to NULL\n");
            exit(0);
        }
    } else {
        printf("Lab 1. Failed --- LinkedList not created\n");
        exit(0);
    }
}

int TESTDATA2_1[10] = {1, 2, 3, 4, 5, 6, 7, -1, 1238, 10};
int TESTDATA2_2[13] = {1, 2, 3, 16, 3, 4, 5, 6, 7, -1, 1238, 10, -2};
int TESTDATA2_3[15] = {2048, 1049, 1, 2, 3, 16, 3, 4, 5, 6, 7, -1, 1238, 10, -2};

void Test2() {
    // Test 2-1
    for (int i = 0; i < 10; i++) {
        addElement2Tail(TESTDATA2_1[i], StudentLinkedList);
    }
    testLinkedList(10, TESTDATA2_1, "Lab 2-1");
    // Test 2-2
    addElement(3, 3, StudentLinkedList);
    addElement(3, 16, StudentLinkedList);
    addElement(183, -2, StudentLinkedList);
    testLinkedList(13, TESTDATA2_2, "Lab 2-2");
    addElement2Head(1049, StudentLinkedList);
    addElement2Head(2048, StudentLinkedList);
    testLinkedList(15, TESTDATA2_3, "Lab 2-3");
}

int TESTDATA3_1[15] = {1049, 1, 2, 16, 4, 5, 6, 7, -1, 1238, 10, -2, 6, 6, 6};
int TESTDATA3_2[13] = {1049, 2, 16, 4, 5, 6, 7, -1, 1238, 10, 6, 6, 6};

void Test3() {
    // Add more node for Test 3
    addElement2Tail(6, StudentLinkedList);
    addElement2Tail(6, StudentLinkedList);
    addElement2Tail(6, StudentLinkedList);
    // Test 3-1
    if (deleteElement(1, 3, StudentLinkedList) != 2) {
        printf("Lab 3-1. Failed --- return value incorrect\n");
        exit(0);
    }
    if (deleteElement(2, 2048, StudentLinkedList) != 1) {
        printf("Lab 3-1. Failed --- return value incorrect\n");
        exit(0);
    }
    testLinkedList(15, TESTDATA3_1, "Lab 3-1");
    //Test 3-2
    if (deleteElement(3, 3, StudentLinkedList) != 1) {
        printf("Lab 3-2. Failed --- return value incorrect\n");
        exit(0);
    }
    if (deleteElement(3, -12, StudentLinkedList) != 0) {
        printf("Lab 3-2. Failed --- return value incorrect\n");
        exit(0);
    }
	if (deleteElement(4, 0, StudentLinkedList) != 1) {
        printf("Lab 3-2. Failed --- return value incorrect\n");
        exit(0);
    }
    testLinkedList(13, TESTDATA3_2, "Lab 3-2");
}


void Test4() {
    for (int i = 0; i < 13; i++) {
        int rt = peekElement(i, StudentLinkedList);
        if (rt != TESTDATA3_2[i]) {
            printf("Lab 4. Failed --- return value incorrect, found %d, expected %d\n", rt, TESTDATA3_2[i]);
            exit(0);
        }
    }
    if (peekElement(13, StudentLinkedList) != -1) {
        printf("Lab 4. Failed --- return value incorrect, expected -1\n");
        exit(0);
    }
    printf("Lab 4. Passed\n");
}

int TESTDATA5[13] = {-1, 2, 16, 4, 5, 6, 7, -1, 28, 10, 6, 128736, 6};

void Test5() {
    if (replaceElement(0, -1, StudentLinkedList) != 1) {
        printf("Lab 5. Failed --- return value incorrect\n");
        exit(0);
    }
    if (replaceElement(11, 128736, StudentLinkedList) != 1) {
        printf("Lab 5. Failed --- return value incorrect\n");
        exit(0);
    }
    if (replaceElement(8, 28, StudentLinkedList) != 1) {
        printf("Lab 5. Failed --- return value incorrect\n");
        exit(0);
    }
    if (replaceElement(13, 28, StudentLinkedList) != -1) {
        printf("Lab 5. Failed --- return value incorrect\n");
        exit(0);
    }
    testLinkedList(13, TESTDATA5, "Lab 5");
}

void testLinkedList(int length, int *testdata, char *INFO) {
    if (StudentLinkedList->elementCount != length) {
        printf("%s. Failed --- elementCount mismatch, found %d, expected %d\n", INFO, StudentLinkedList->elementCount,
               length);
        exit(0);
    }
    ListNode *p = StudentLinkedList->head;
    if (p == NULL) {
        printf("%s. Failed --- element mismatch, found NULL, expected %d\n", INFO, TESTDATA2_1[0]);
    }
    for (int i = 0; i < length; i++) {
        if (p->element != testdata[i]) {
            printf("%s. Failed --- element mismatch, found %d, expected %d\n", INFO, p->element, testdata[i]);
            exit(0);
        }
        p = p->next;
    }
    if (p != NULL) {
        printf("%s. Failed --- LinkedList **NOT** ended with NULL pointer\n", INFO);
    }
    printf("%s. Passed\n", INFO);
}

void judge() {
    int TestID;
    scanf("%d", &TestID);
    if (TestID == 1) {
        Test1();
    } else if (TestID == 2) {
        Test1();
        Test2();
    } else if (TestID == 3) {
        Test1();
        Test2();
        Test3();
    } else if (TestID == 4) {
        Test1();
        Test2();
        Test3();
        Test4();
    } else if (TestID == 5) {
        Test1();
        Test2();
        Test3();
        Test4();
        Test5();
    }
}

#endif